summaryrefslogtreecommitdiff
path: root/plugins
diff options
context:
space:
mode:
authorMichaƂ Duszyk <mdevel@protonmail.com>2021-06-13 19:40:07 +0200
committerGitHub <noreply@github.com>2021-06-13 10:40:07 -0700
commit027189b294d14a7d313cdbf611982843f921555d (patch)
tree104e6fbb46a05c2caf4e3df2bd47a2d497790938 /plugins
parent70a0577712bc8f78e14173c8032df3701ea2887f (diff)
downloadzsh-027189b294d14a7d313cdbf611982843f921555d.tar.gz
zsh-027189b294d14a7d313cdbf611982843f921555d.tar.bz2
zsh-027189b294d14a7d313cdbf611982843f921555d.zip
perf(mercurial): speed up mercurial plugin (#4591)
* speed up mercurial plugin * removed unnecesay limit to current dir from hg status
Diffstat (limited to 'plugins')
-rw-r--r--plugins/mercurial/mercurial.plugin.zsh27
1 files changed, 14 insertions, 13 deletions
diff --git a/plugins/mercurial/mercurial.plugin.zsh b/plugins/mercurial/mercurial.plugin.zsh
index a50dcb523..f4efc2b4a 100644
--- a/plugins/mercurial/mercurial.plugin.zsh
+++ b/plugins/mercurial/mercurial.plugin.zsh
@@ -19,37 +19,38 @@ alias hglr='hg pull --rebase'
alias hgo='hg outgoing'
function in_hg() {
- if [[ -d .hg ]] || $(hg summary > /dev/null 2>&1); then
+ if $(hg branch > /dev/null 2>&1); then
echo 1
fi
}
function hg_get_branch_name() {
- if [ $(in_hg) ]; then
- echo $(hg branch)
+ branch=`hg branch 2>/dev/null`
+ if [ $? -eq 0 ]; then
+ echo $branch
fi
+ unset branch
}
function hg_prompt_info {
- if [ $(in_hg) ]; then
- _DISPLAY=$(hg_get_branch_name)
+ _DISPLAY=`hg branch 2>/dev/null`
+ if [ $? -eq 0 ]; then
echo "$ZSH_PROMPT_BASE_COLOR$ZSH_THEME_HG_PROMPT_PREFIX\
$ZSH_THEME_REPO_NAME_COLOR$_DISPLAY$ZSH_PROMPT_BASE_COLOR$ZSH_PROMPT_BASE_COLOR$(hg_dirty)$ZSH_THEME_HG_PROMPT_SUFFIX$ZSH_PROMPT_BASE_COLOR"
- unset _DISPLAY
fi
+ unset _DISPLAY
}
function hg_dirty_choose {
- if [ $(in_hg) ]; then
- hg status 2> /dev/null | command grep -Eq '^\s*[ACDIM!?L]'
+ hg status -mar 2> /dev/null | command grep -Eq '^\s*[ACDIM!?L]'
+ if [ $? -eq 0 ]; then
if [ $pipestatus[-1] -eq 0 ]; then
# Grep exits with 0 when "One or more lines were selected", return "dirty".
echo $1
- else
- # Otherwise, no lines were found, or an error occurred. Return clean.
- echo $2
+ return
fi
fi
+ echo $2
}
function hg_dirty {
@@ -57,11 +58,11 @@ function hg_dirty {
}
function hgic() {
- hg incoming "$@" | grep "changeset" | wc -l
+ hg incoming "$@" | grep "changeset" | wc -l
}
function hgoc() {
- hg outgoing "$@" | grep "changeset" | wc -l
+ hg outgoing "$@" | grep "changeset" | wc -l
}
function hg_get_bookmark_name() {